import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const provinceGetAgeMessagesService = createAsyncThunk(
  "GET_AGE_MESSAGES",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    const { data, status } = await axios.get("age-notification-poultry/");
    dispatch(LOADING_END());
    return { data, status };
  }
);

export const provinceEditAgeMessagesService = createAsyncThunk(
  "EDIT_AGE_MESSAGES",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.put(
        "age-notification-poultry/0/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceSubmitAgeMessagesService = createAsyncThunk(
  "SUBMIT_AGE_MESSAGES",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.post("age-notification-poultry/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceDeleteAgeMessagesService = createAsyncThunk(
  "DELETE_AGE_MESSAGES",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        "age-notification-poultry/0/?notif_key=" + d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
